local GearEvaluator = _G.GearEvaluator
local GearEvaluator_Outfitter = GearEvaluator:NewModule("Outfitter", "AceHook-3.0")

function GearEvaluator_Outfitter:OnInitialize()
  local defaults = {
    char = {
      bestscores = {}
    }
  }

  self.db = GearEvaluator.db:RegisterNamespace("Outfitter", defaults)
end

function GearEvaluator_Outfitter:OnEnable()
  self:RawHook(GearEvaluator, "GetScore")
  self:Hook(GearEvaluator, 'UpdateEvaluatorFunction')
end

function GearEvaluator_Outfitter:OnDisable()
  self:Unhook(GearEvaluator, 'UpdateEvaluatorFunction')
  self:Unhook(GearEvaluator, "GetScore")
end

function GearEvaluator_Outfitter:GetScore(object, evalname, gear)
  local success, score = self.hooks[object].GetScore(object, evalname, gear)
  local outfit = Outfitter:FindOutfitByName(evalname)

  if (success and outfit and score > (self.db.char.bestscores[evalname] or -math.huge)) then
    GearEvaluator:Print("Updating Outfitter set "..evalname.." with new best score "..score)

    for slot, item in pairs(gear) do
      Outfitter:AddOutfitItem(outfit, slot, Outfitter:GetItemInfoFromLink(item))
    end

    self.db.char.bestscores[evalname] = score
  end

  return success, score
end

function GearEvaluator_Outfitter:UpdateEvaluatorFunction(object, info, func)
  self.db.char.bestscores[name] = nil
end
